
/******************************************************************************
* MODULE     : conv_uncross.cc
* DESCRIPTION: Select an argument in a Cross instance
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <evaluator.hh>
#include <single.hh>
namespace mmx {

void
evaluator_rep::kw_conv_uncross_1 () {
  evaluate_arg (car(trace)[1], KW_CONV_UNCROSS_2);
}

void
evaluator_rep::kw_conv_uncross_2 () {
  // INPUT: (conv_uncross_2, tuple, cont, ...)
  int   i= as_int (car (trace) [2]);
  value v= as_value (car (rem));
  cur= cadr (rem);
  rem= cons (value (v->val[i], v->type[i]), cddr (rem));
  // OUTPUT: (cont, member, ...)
  trace= cdr (trace);
}

} // namespace mmx
