
/******************************************************************************
* MODULE     : keyw_local.cc
* DESCRIPTION: Local environments
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <evaluator.hh>
#include <xtable.hh>
namespace mmx {

void
evaluator_rep::kw_local_1 () {
  env= xtable (env, table ());
  list loc= as_list (car (trace));
  generic instr= cons (symbol ("begin!", car (loc)), cdr (loc));
  evaluate_arg (instr, KW_LOCAL_2);
}

void
evaluator_rep::kw_local_2 () {
  // INPUT: (local_2, result, cont, ...)
  xtable xenv= as_xtable (env);
  env= xenv->base_t;
  cur= cadr (rem);
  rem= cons (car (rem), cddr (rem));
  // OUTPUT: (cont, result, ...)
  trace= cdr (trace);
}

} // namespace mmx
