
/******************************************************************************
* MODULE     : keyw_quantor.cc
* DESCRIPTION: Evaluate quantor types (forall and exists)
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <evaluator.hh>
#include <xtable.hh>
namespace mmx {

void
evaluator_rep::kw_quantor_1 () {
  generic qt= car(trace);
  table xtra= table ();
  xtra (qt[1])= value (qt[1], ID_UNIVERSAL);
  env= xtable (env, xtra);
  evaluate_arg (qt[2], KW_QUANTOR_2);
}

void
evaluator_rep::kw_quantor_2 () {
  // INPUT: (quantor_2, body, cont, ...)
  generic qt= (car (trace) [0] == MMX_FORALL? ID_FORALL: ID_EXISTS);
  value body= as_value (car (rem));
  generic result= list (qt, car (trace) [1], body->val);
  xtable xenv= as_xtable (env);
  env= xenv->base_t;
  cur= cadr (rem);
  rem= cons (value (result, ID_CLASS), cddr (rem));
  // OUTPUT: (cont, quantor_type, ...)
  trace= cdr (trace);
}

} // namespace mmx
