
/******************************************************************************
* MODULE     : mmx_extern.H
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/
#ifndef __MMX_EXTERN_HH
#define __MMX_EXTERN_HH
#include <generic.hh>

template<class R> struct mm_obj;
template<class R> mm_obj<R> copy (mm_obj<R> t);
template<class R> std::ostream& operator << (std::ostream&, mm_obj<R>);
template<typename R>
struct mm_rep: generic_rep {
private:
public:
  R data;  // the ostream

protected:
  int Type ();
  //  int Hash ();
  bool Equal (generic g);
  generic Copy ();
  int Arity ();
  void Print (std::ostream& out);

public:
  static const int TYPE=3000; // XXXX
  inline mm_rep (const R & r): data (r) {}
  friend class mm_obj<R>;
  friend mm_obj<R> copy<> (mm_obj<R> t);
  friend std::ostream& operator << <> (std::ostream& out, mm_obj<R> a);
};

template<class R>
struct  mm_obj {
protected:
  mm_rep<R>* rep;
  inline mm_obj<R> (mm_rep<R>* r): rep (r) {}

public:
  inline mm_obj<R> (const R & r): rep (new mm_rep<R> (r)) {}
  friend mm_obj<R> as_mm_obj <> (generic g);

  inline operator R () { return rep->rep; }
  inline operator generic () { return generic (rep); }
  inline mm_rep<R>* operator -> () { return rep; }
  inline mm_rep<R>* operator -> () const { return rep; }

  inline bool operator == (const mm_obj<R>& out) 
    { return (rep->data == out->data); }
  inline bool operator != (const mm_obj<R>& out) 
    { return (rep->data != out->data); }
  friend mm_obj<R> copy <> (mm_obj<R> x);
  friend std::ostream& operator<< <> (std::ostream& out, mm_obj<R> x);
  friend class mm_rep<R>;
};

#include "mmx_extern.C"

#endif // __MMX_EXTERN_HH
